package de.cscherr.mcpht.mixin.client;

import de.cscherr.mcpht.MCPHTClient;
import net.minecraft.block.Block;
import net.minecraft.block.BlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Direction;
import net.minecraft.world.BlockView;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(Block.class)
public abstract class MixinBlock {
    @Inject(at = @At("RETURN"), method = "shouldDrawSide(" + "Lnet/minecraft/block/BlockState;" + // state
            "Lnet/minecraft/world/BlockView;" + // reader
            "Lnet/minecraft/util/math/BlockPos;" + // pos
            "Lnet/minecraft/util/math/Direction;" + // face
            "Lnet/minecraft/util/math/BlockPos;" + // blockPos
            ")Z", // ci
            cancellable = true)
    private static void shouldDrawSide(BlockState state,
                                       BlockView world,
                                       BlockPos pos,
                                       Direction side,
                                       BlockPos otherPos,
                                       CallbackInfoReturnable<Boolean> cir
    ) {
        if (MCPHTClient.XRAY.getEnable()) {
            cir.setReturnValue(MCPHTClient.XRAY.showRenderBlock(state));
        }
    }
}